#ifndef lcd_hh_included
#define lcd_hh_included

#include <inttypes.hh>
#include <module.hh>
#include <device.hh>
#include <serial.hh>
#include <checkpoint.hh>
#include <simarg.hh>


class U4600_LCD
    : public Module, public Device
{
private:

    static SerialType<U4600_LCD> type;

    char lcd_contents[4];

    void show_lcd();

public:

    // Constructors, etc.
    U4600_LCD(const SimArgs& args);
    U4600_LCD(Checkpoint& cp);

    // Module interfaces.
    void reset(bool warm);

    // Serialization information.
    void checkpoint(Checkpoint& cp, bool parent = false) const;
    
    // Device access.
    ClockValue read(UInt64 addr, UInt64* buf, int size);
    ClockValue write(UInt64 addr, const UInt64* buf, int size);

};

#endif // lcd_hh_included
