#ifndef ioqueue_hh_included
#define ioqueue_hh_included

#include <sys/types.h>

// class implemented by devices interested in IO notifications
class IOListener
{
	friend class IOQueue;

	IOListener *io_next;
	virtual void io_poll() = 0;

protected:
	int io_fd;
};

class IOQueue
{
	IOListener *queue;
	fd_set fds;
	int max_fd;

public:
	IOQueue();
	void insert(IOListener *listener);
	void remove(IOListener *listener);
	void poll();
};

// Master IO queue polled on SIGIO
extern IOQueue *ioqueue;

#endif // ioqueue_hh_includd
