#ifndef mips64_bus_hh_included
#define mips64_bus_hh_included

#include <checkpoint.hh>
#include <clock.hh>
#include <bus.hh>
#include <cpu.hh>
#include <inttypes.hh>
#include <mips64/types.hh>
#include <module.hh>
#include <serial.hh>
#include <simarg.hh>


// MIPS64Bus describes the external interface of a MIPS64 CPU module.

class MIPS64Cpu;

class MIPS64Bus
    : public virtual Bus, public virtual Serializable, public Module, public MIPS64Types
{
public:

    // Constructors, etc.

    MIPS64Bus(const SimArgs& args)
	: Module(args) { }
    MIPS64Bus(Checkpoint& cp)
	: Serializable(cp), Module(cp) { }

};


#endif // mips64_bus_hh_included
