#include "regdef.h"

/*
		
	__start()
	--------------------------------------------------------------

	A stub  that sets  up the  C stack and  jumps to  the function
	load_image(),  which returns  the  entry point  into the  boot
	loader.  Upon return  from load_image(), __start() immediately
	jumps  to  that  address,  thus completing  the  boot  loading
	process.

*/	
	.text

	.globl	__start
	.ent	__start
__start:	
	la	sp, 0xFFFFFFFFA0000000 + 4096
	jal	load_image
	jr	v0
	.end	__start
	
/*

	abort()
	--------------------------------------------------------------

	Abort the simulator using Sulima private opcode, break 666.

*/

	.globl	abort
	.ent	abort	
abort:
	break	666
	.end	abort

/*

	wbflush()
	--------------------------------------------------------------

	Write barrier.

*/

	.globl	wbflush
	.ent	wbflush
wbflush:
        sync 
        jr      ra
	.end	wbflush
