/*

	strlen(s)
	isspace(c)
	putchar(c)
	puts(s)
	bcmp(s1, s2, n)
	bcopy(src, dst, n)
	--------------------------------------------------------------

	Simple implementations  of the corresponding  ISO C functions.
	putc() does  not print the  final newline, and  some functions
	use  ints instead  of  size_t, and  don't  return values  like
	they're supposed to. bcmp() and bcopy() comes from BSD.

*/

#include "termio.h"

unsigned long strlen(
    const char* s)
{
    int n = 0;
    for (; *s != '\0'; ++s)
	++n;
    return n;
}

int isspace(
    int c)
{
    return c == ' ' || c == '\t' || c == '\n' || c == '\r';
}

void putchar(
    int c)
{
#if 0
    *(volatile char *)(0xFFFFFFFFBF400008 ^ 7) = c;
#else
    while(!pzscc(OP_TXRDY, 0xFFFFFFFFBC800030, 0, 0));
    pzscc(OP_TX, 0xFFFFFFFFBC800030, 0, c);
#endif
}

void puts(
    const char* s)
{
    while (*s)
	putchar(*s++);
}

int bcmp(
    const void* src,
    const void* dst,
    int n)
{
    const char* p = src;
    const char* q = dst;

    while (n > 0) {
	if (*p != *q)
	    break;
	++p, ++q, --n;
    }
    return 0;
}

void bcopy(
    const void* src,
    void* dst,
    int n)
{
    if (((long)src & 3) == 0 && ((long)dst & 3) == 0 && (n & 3) == 0) {
	/* Fast aligned copy. */
	const int* p = src;
	int* q = dst;
	for (; n > 0; n -= 4)
	    *q++ = *p++;
    }
    else {
	/* Slow byte copy. */
	const char* p = src;
	char* q = dst;;
	for (; n > 0; --n)
	    *q++ = *p++;
    }
}
