#include <assert.hh>
#include "koala.hh"
#include "instr.hh"

int
Koala::decode_cache(Instr instr)
{
    // CP0 is usable in kernel more or when the CU bit in SR is set.
    if (!(mode & kmode) && !bit(cp0[SR], SR_CU0))
	process_coprocessor_unusable(0);
    VA va = sign_extend<VA>(offset(instr), 16) + gpr[base(instr)];
    PA pa = translate_vaddr(va, cache_op);
    if (pa != bad_pa) {
	if (bit(instr, 16)) {
	    // Control data cache.
	    control_dcache(va, pa, bits(instr, 20, 18), bit(instr, 17));
	}
	else {
	    // Control instruction cache.
	    control_icache(va, pa, bits(instr, 20, 18), bit(instr, 17));
	}
    }
    return nothing_special;
}
