#include "koala.hh"

SerialType<Koala::Timer> Koala::Timer::type(
    "Koala::Timer"
);

Koala::Timer::Timer(Checkpoint& cp)
    : Serializable(cp), Event(cp)
{
    SerialID cid = extract<SerialID>(cp);
    cpu = dynamic_cast<Koala *>(find_object(cid));
    if (!cpu)
	throw Checkpoint::SyntaxError(cp, "%d is not a Koala module ID", cid);
}

void
Koala::Timer::invoke()
{
    cpu->deliver_interrupt(5);
}

void
Koala::Timer::checkpoint(Checkpoint& cp, bool parent) const
{
    if (parent)
	cp << type << ' ' << id << '\n';
    Event::checkpoint(cp);
    cp << cpu->id << '\n';
}

void
Koala::set_timer()
{
    if (timer != NULL)
    {
	remove(timer);
	delete timer;
    }

    timer = new Timer(this, now + (cp0[Compare] - (cp0[Count] + ((now - count_seed) / 2))) * 2);
    insert(timer);
}
