# Sulima configuration to simulate U4600

set sim::log_enabled 0

sim::install "MT48Tx2" "nvram"
namespace eval sim::nvram {
    set fileName	$env(NVRAM)
}

sim::install "U4600_LCD" "lcd"

sim::install "U4600_PIC" "intctrl"

sim::install "ZilogESCC" "serial"
namespace eval sim::serial {
    set irq		2
    set debugirq	4
}

sim::install "ROM" "rom"
namespace eval sim::rom {
    set fileName	$env(ROM)
    set size		2048
}

sim::install "Tulip" "network"

sim::install "MIPS64SimpleBus" "bus"
namespace eval sim::bus {
    set memory		64
    set cpu		"cpu"
    set cs0		"nvram"
    set cs1a		"lcd"
    set cs1c		"intctrl"
    set cs1d		"serial"
    set bootcs		"rom"
    set pciintctrl	"intctrl"
    set pci1		"network"
}

sim::install "koala-R4600" "cpu" 100
namespace eval sim::cpu {
    set bigEndian	1
    set bus		"bus"
    set traceLevel	0
}

set sim::console "serial"

sim::msg "Avaliable modules:"
sim::list available

sim::msg "Installed modules:"
sim::list installed

sim::msg "Resetting hardware...."
sim::reset

sim::msg "Beginning simulation...."
sim::run "cpu"

