#include <stdio.h>
#include <string.h>
#include "checkpoint.hh"
#include "cpu.hh"
#include "module.hh"
#include "sulima.hh"


// Some shameless advertising.
const char *const Sulima::banner
	= "Sulima v1.0.0 built on " __DATE__ ", " __TIME__;
const char *const Sulima::copyright
	= "Copyright (C) 1998-2000 Patryk Zadarnowski";


// Constructor.
Sulima::Sulima()
    : BasicModule("Sulima")
{
    // Print some welcome message.
    puts(banner);
    puts(copyright);
    putchar('\n');
    // Initialize the logging and console subsystems.
    create_logging_subsystem();
    create_io_subsystem();
    create_console_subsystem();
    // Define the Tcl interfaces.
    define("list",	 list_known_modules);
    define("checkpoint", Checkpoint::create);
    define("restore",    Checkpoint::restore);
    define("install",    Module::install_module);
    define("reset",      Module::reset_all);
    define("run",        CPU::run_all);
}


// Destructor.
Sulima::~Sulima()
{
    destroy_console_subsystem();
    destroy_io_subsystem();
    destroy_logging_subsystem();
}


// The main simulator module, created by Tcl_Main (see: main.cc)
Sulima *sulima;
